{
        Program Name : Altair
        Package Name : CEF
        Purpose      : Altair 8800 emulator
        Institution  : Conroy & Conroy Co.
        Date Written : 13-Jan-2007
        Written By   : Alan Conroy
        Version      : 1.0

	Copyright (C) 2007 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          Provides an Altair 8800 microcomputer.
}

library Altair ;

uses
  Forms,
  _App,
  App,
  CEF,
  MITS_Altair,
  Altair_Form in 'Altair_Form.pas' {Front_Panel_Form},
  Port_Dialog in 'Port_Dialog.pas' {Port_Form},
  Port_Change_Dialog in 'Port_Change_Dialog.pas' {Port_Change_Form},
  Add_Port_Dialog in 'Add_Port_Dialog.pas' {Add_Port_Form};

{$R *.res}

function Facility_Code : integer ; stdcall ;

begin
    Result := MITSAltair_Facility ;
end ;


function Make_Instance( Serial_Number : integer ;
    UI : TUI_Interface ) : TMITS_Altair ; stdcall ;

begin
    Result := TMITS_Altair.Create ;
    Result.Initialize( UI ) ;
    Result._Serial_Number := Serial_Number ;
end ;


function Version : longint ;

begin
    Version := 20 ; // Version 2.0
end ;


{$WARNINGS OFF}
exports Facility_Code index 0,
        Make_Instance index 1,
        Version index 2 ;
{$WARNINGS ON}


var F : TForm ;

begin
    Application.Initialize ;
    Application.CreateForm( TForm, F ) ;
    F.Visible := False ;
    { Delphi kills the DLL when the first created form is closed, so create this
      form so if the Front Panel is destroyed (by terminating the TMITS_Altair
      object), the DLL remains. }
end.

