1	EXTEND
2	!	Program Name	:  &
	!	Package Name	: LB &
	!	Purpose		:  &
	!	Institution	: Conroy & Conroy Company &
	!	Date Written	:  &
	!	Written by	:  &
	!	Version		:  &
	!	&
	!	TO THE GLORY OF GOD THROUGH JESUS CHRIST &
	!	&
	! ******************************************************* &
	! *							* &
	! *	M O D I F I C A T I O N   H I S T O R Y		* &
	! *							* &
	! *	DATE	BY	REASON				* &
	! *							* &
	! ******************************************************* &
	!	&
	! ******************************************************* &
	! *							* &
	! *	P R O G R A M   P U R P O S E			* &
	! *							* &
	! ******************************************************* &
	!	&
	! ******************************************************* &
	! *							* &
	! *	V A R I A B L E   T A B L E			* &
	! *							* &
	! ******************************************************* &
	!	&
	! ******************************************************* &
	! *							* &
	! *	F I L E   D E S C R I P T I O N S		* &
	! *							* &
	! ******************************************************* &
	!	&
	!	Channel		Name		Description &
	!	-------		----		----------- &
	! &
	! ******************************************************* &
	! *							* &
	! *	D I M E N S I O N   S T A T E M E N T S		* &
	! *							* &
	! ******************************************************* &
	!	&
	! ******************************************************* &
	! *							* &
	! *	C O N S T A N T   D E C L A R A T I O N S	* &
	! *							* &
	! ******************************************************* &
	! &
	True%=-1%			! Standard boolean true value &
\	False%=0%			! Standard boolean false value &
\	Null$ = ''			! Standard null value &
\	Version$=''		! Current version &
\	Program$=''		! Name of program &
\	ON ERROR GOTO 29000		! Setup up standard error trap &

10	OPEN '_KB:'+Program$+'.CMD' AS FILE 1%
20	IF CCL%=False% &
		THEN &
			PRINT #1%,'' IF CCPOS(1%)>0% &
\			PRINT #1%,Program$;' ';Version$;' '; &
				RIGHT(SYS(CHR$(6%)+CHR$(9%)+CHR$(0%)),3%); &
				' ';DATE$(0%);' at ';TIME$(0%) &
\			PRINT #1%,'' &


29000	! &
	! ******************************************************* &
	! *							* &
	! *	E R R O R   H A N D L I N G			* &
	! *							* &
	! ******************************************************* &
	!	&

29000	PRINT RIGHT(SYS(CHR$(6%)+CHR$(9%)+CHR$(ERR)),3%);' at line';ERL &
\	GOTO 32767 &

30000	! &
	! ******************************************************* &
	! *							* &
	! *	C C L   E N T R Y   P O I N T			* &
	! *							* &
	! ******************************************************* &
	!	&
	CCL% = -1% &

30010	GOTO 1 ! If entry here and no routine, jumpto beginning &

31000	! &
	! ******************************************************* &
	! *							* &
	! *	P S C   C H A I N   E N T R Y   P O I N T	* &
	! *							* &
	! ******************************************************* &
	! &
	! Local variables: &
	! &
	! PSC.Program$			The name of the program to chain to &
	!				upon exiting the program. &
	! PSC.Line$			The line-number to chain to of the &
	!				program named in PSC.Program$ &
	! PSC.Command$			A temporary variable used to get &
	!				the command from core-common &
	! PSC.Text$			The text in core-common, placed back &
	!				into core-common upon program exit. &
	! Note: These four variables should not be modified by the user, &
	!	though they are called local. &
	! A$				Dummy string used to initially get &
	!				core-common. &
	! A%				Dummy variable for instrs, etc. &
	! B$				Same as a%. &
	! &
	! Routine entry points &
	! &
	! Line		Entry conditions &
	! 31000		Initial entry point for chain &
	! 31500		Initial point for leaving program &
	! 31900		Internal entry point (should not be called) for errors &
	!	&
	PSC% = -1% &
\	A$=SYS(CHR$(7%)) ! Get core-common &
\	LSET Null$=SYS(CHR$(8%+'') ! And clear it &
\	A%=INSTR(1%,A$+'@','@') ! Find first delimiter (@,\, or ;) &
\	A%=INSTR(1%,A$+'\','\') UNLESS A%<INSTR(1%,A$+'\','\') &
\	A%=INSTR(1%,A$+';',';') UNLESS A%<INSTR(1%,A$+';',';') &
\	PSC.Program$=LEFT(A$,A%-1%) ! Get program name &
\	A$=RIGHT(A$,1%) ! and strip it from command string &
\	PSC.Line%=0% ! Default line-number to zero (0) &
\	IF LEFT(A$,1%)='@' ! If a line-number follows &
		THEN &
			A%=INSTR(1%,A$+'\','\') ! Find next delimiter (\ or;) &
\			A%=INSTR(1%,A$+';',';') UNLESS A%<INSTR(1%,A$+';',';') &
\			ON ERROR GOTO 31900 ! Set PSC error trap &
\			PSC.Line%=VAL(MID(A$,2%,A%-2%)) ! Set line-number &
\			A$=RIGHT(A$,A%) ! and trim it from command string &

31010	IF LEFT(A$,1%)<>'\' ! If not a command &
		THEN &
			31040 &
		ELSE &
			AA=1% &

31020	A%=INSTR(A%+1%,A$+'\','\') &
\	IF INSTR(A%+1%,A$,'\\')<>A% ! If not a double slash &
		THEN &
			PSC.Command$=MID(A$,2%,A%-2%) ! Grab command &
		ELSE &
			A%=A%+1% ! Otherwise, skip slashes &
\			GOTO 31020 ! and continue to look for the end &

31030	A%=0% ! Reset string pointer &

31040	A%=INSTR(A%+1%,PSC.Command$,'\\') ! If any double slashes &
\	IF A% &
		THEN &
			PSC.Command$=LEFT(PSC.Command$,A%)+ &
			    RIGHT(PSC.Command$,A%+2%) ! Reduce to one slash &
\			A%=A%+1% &
\			GOTO 31040 ! Look for next double-slash &

31050	IF LEFT(A$,1%)=';' ! If a command &
		THEN &
			PSC.Text$=RIGHT(A$,2%) ! Grab it &
!		ELSE &
!			Ignore it &

31060	ON ERROR GOTO 0 ! Reset error trap &
\	IF LEN(PSC.Command$)=0% ! If no command &
		THEN &
			1 ! Begin execution &
		ELSE &
			LSET Null$=SYS(CHR$(8%)+PSC.Command$) ! Put command &
							      ! into core- &
							      ! common. &
\			PSC.Command$='' &
\			GOTO 30000 ! And force a CCL entry &

31500	ON ERROR GOTO 31900 ! Set up PSC error handling &
\	LSET Null$=SYS(CHR$(8%)+PSC.Text$) ! Put comment text into core-common &
\	CHAIN PSC.Program$ LINE PSC.Line% IF LEN(PSC.Program$) &
!	If there is a filename to chain to, do so &
\	PSC%=False% &
\	GOTO 32767 ! and exit &

31900	! PSC error handling &
	IF ERL<31000% OR ERL>31999% ! If not a PSC error &
		THEN &
			ON ERROR GOTO 0 ! Halt in error &
		ELSE &
	IF ERL=31000% ! If a bad line-number &
		THEN &
			PRINT '%PSC - Illegal line number' &
\			PSC.Line%=0% ! Default line number to zero (0) &
\			A$=RIGHT(A$,A%) ! Trim line number &
\			RESUME 31010 ! And resume &

31910	IF ERL=31900% ! If a chaining problem &
		THEN &
			PRINT RIGHT(SYS(CHR$(6%)+CHR$(9%)+CHR$(ERR)),3%); &
			    ' during PSC chain.' &
\			PSC%=False% ! Reset PSC flag &
\			RESUME 32767 &

31920	PRINT RIGHT(SYS(CHR$(6%)+CHR$(9%)+CHR$(ERR)),3%);' while under PSC control.' &
\	A$=SYS(CHR$(9%)) ! Clear &

32000	! &
	! ******************************************************* &
	! *							* &
	! *	D A T A   S T A T E M E N T S			* &
	! *							* &
	! ******************************************************* &
	! &

32767	GOTO 31500 IF PSC% &
\	LSET Null$ = SYS(CHR$(9%)) &
\	END
