/*
              Program Name : WIND
              Package Name : LB
              Purpose      : Determine wind-chill factor
              Institution  : Conroy & Conroy Co.
              Date Written : 31-May-87
              Written By   : Alan Conroy
              Version      : 1.0

	      Copyright (C) 1987 by Alan Conroy.  Released to the public domain.

              TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *********************************************************
        *                                                       *
        *        M O D I F I C A T I O N   H I S T O R Y        *
        *                                                       *
        *     DATE      BY             REASON                   *
        *                                                       *
        *********************************************************

        *********************************************************
        *                                                       *
        *           P R O G R A M   P U R P O S E               *
        *                                                       *
        *********************************************************

          Determine wind-chill factor (in oF).  Wind chill factor depends on
	wind speed (in mph) and ambient temperature (in Farenheit).
*/

#include <math.h>
#include "wind.h"

double Wind( double Speed, double Temperature )
{

double A ;

    A = 0 ;
    if( Speed >= 0 )
    {
	A = 0.0817 * ( 3.71 * sqrt( Speed ) + 5.81 - 0.25 * Speed ) *
	    ( Temperature - 91.4 ) + 91.4 ;
    } ;
    if( A > 0 )
    {
	A = 0 ;
    } ;
    return A ;
} ;
