/*
              Program Name : Instr
              Package Name : LB
              Purpose      : Search within a string function
              Institution  : Conroy & Conroy
              Date Written : 19-Dec-86
              Written By   : Alan Conroy
              Version      : 1.2

	      Copyright (C) 1986 by Alan Conroy.  Released to the public domain.

	TO THE GLORY OF GOD THROUGH JESUS CHRIST.

        *********************************************************
        *                                                       *
        *        M O D I F I C A T I O N   H I S T O R Y        *
        *                                                       *
        *     DATE      BY             REASON                   *
        *                                                       *
        *********************************************************

        *********************************************************
        *                                                       *
        *           P R O G R A M   P U R P O S E               *
        *                                                       *
        *********************************************************

          This function returns the position within a string of a
        substring, starting at a specified character.  Format:
        X = instr(start, string, sub), where X is the returned value,
        start is the starting position (not offset), string is the
	string to search, and sub is the string to search for.
*/

#include <string.h>
#include "instr.h"

int Instr( int Position, char *C, char *Search_String )
{

char *X ;

    if( C == NULL || Search_String == NULL )
    {
	return 0 ;
    } ;
    if( Position > strlen( C ) )
    {
	return 0 ;
    } ;
    if( Position < 1 )
    {
	Position = 1 ;
    } ;
    X = strstr( &C[ Position - 1 ], Search_String ) ;
    if( X == NULL ) /* Not found */
    {
	return 0 ;
    } ;
    return X - C + 1 ;
} ;
