;              Program Name : ASCIIDEF
;              Package Name : LB
;              Purpose      : Definitions of ASCII constants
;              Institution  : Conroy & Conroy Co.
;              Date Written : 23-Apr-1995
;              Written By   : Alan Conroy
;              Version      : 1.0
;
;              Copyright (c) 1995 by Alan Conroy.  Released to the public domain.
;
;	       TO THE GLORY OF GOD THROUGH JESUS CHRIST
;
;        *********************************************************
;        *                                                       *
;        *        M O D I F I C A T I O N   H I S T O R Y        *
;        *                                                       *
;        *     DATE      BY             REASON                   *
;        *                                                       *
;        *********************************************************
;
;        *********************************************************
;        *                                                       *
;        *           P R O G R A M   P U R P O S E               *
;        *                                                       *
;        *********************************************************
;

	_NUL EQU 0 ; Null
	_SOH EQU 1 ; Start Of Heading
	_STX EQU 2 ; Start Text
	_ETX EQU 3 ; End Text
	_EOT EQU 4 ; End Of Transmission
	_ENQ EQU 5 ; Enquiry
	_ACK EQU 6 ; Acknowledge
	_BEL EQU 7 ; Bell
	_BS EQU 8 ; Backspace
	_HT EQU 9 ; Horizontal Tab
	_LF EQU 10 ; Line Feed
	_VT EQU 11 ; Vertical Tab
	_FF EQU 12 ; Form Feed
	_CR EQU 13 ; Carriage return
	_SO EQU 14 ; Shift Out
	_SI EQU 15 ; Shift In
	_DLE EQU 16 ; Data Link Escape
	_DC1 EQU 17 ; Direct Control 1
	_DC2 EQU 18 ; Direct Control 2
	_DC3 EQU 19 ; Direct Control 3
	_DC4 EQU 20 ; Direct Control 4
	_NAK EQU 21 ; Negative Acknowledge
	_SYN EQU 22 ; Synchronous idle
	_ETB EQU 23 ; End Tranmission Block
	_CAN EQU 24 ; Cancel
	_EM EQU 25 ; End of Medium
	_SUB EQU 26 ; Substitute
	_ESC EQU 27 ; Escape
	_FS EQU 28 ; Form separator
	_GS EQU 29 ; Group separator
	_RS EQU 30 ; Record separator
	_US EQU 31 ; Unit separator
	_Space EQU 32 ;
	_SP EQU 32 ; Space
	_DEL EQU 127 ; Delete

	; DEC upplemental codes...
	_IND EQU 132
	_NEL EQU 133
	_SSA EQU 134
	_ESA EQU 135
	_HTS EQU 136
	_HTJ EQU 137
	_VTS EQU 138
	_PLD EQU 139
	_PLU EQU 140
	_RI EQU 141
	_SS2 EQU 142
	_SS3 EQU 143
	_DCS EQU 144
	_PU1 EQU 145
	_PU2 EQU 146
	_STS EQU 147
	_CCH EQU 148
	_MW EQU 149
	_SPA EQU 150
	_EPA EQU 151
	_CSI EQU 155
	_ST EQU 156
	_OSC EQU 157
	_PM EQU 158
	_APC EQU 159
	_NBSP EQU 160
	
;	Codes used by SMU...
	_EBS EQU 254 ; Extended backspace

	END
