/*
              Program Name : Nums
              Package Name : LB
              Purpose      : Convert numbers to string
              Institution  : Conroy & Conroy Compnay
              Date Written : 03-Apr-87
              Written By   : Alan Conroy
              Version      : 1.0

	      Copyright (C) 1987 by Alan Conroy.  Released to the public domain.

              TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *********************************************************
        *                                                       *
        *        M O D I F I C A T I O N   H I S T O R Y        *
        *                                                       *
        *     DATE      BY             REASON                   *
        *                                                       *
        *********************************************************

        *********************************************************
        *                                                       *
        *           P R O G R A M   P U R P O S E               *
        *                                                       *
        *********************************************************

          These functions return a string version of the passed number
        nicely formatted.
*/

#include <stdio.h>

#include "nums.h"

char *Num( long X )
{

static char Buffer[ 11 ] ;
int B ;

    Buffer[ sprintf( &Buffer, "%li", X ) ] = 0 ; /* Convert */
    return &Buffer ; /* Return result */
} ;


char *Num1( double X )
{

static char Buffer[ 256 ] ;
int B ;

    B = sprintf( &Buffer, "%-1.32lf", X ) ; /* Convert */
    Buffer[ B ] = 0 ;
    B = B - 1 ;
    while( Buffer[ B ] == '0' || Buffer[ B ] == ' ' )
    {
	B = B - 1 ;
    } ;
    if( Buffer[ B ] == '.' )
    {
	B = B - 1 ;
    } ;
    Buffer[ B + 1 ] = 0 ;
    return &Buffer ; /* Return result */
} ;


char *Num2( long double X )
{

static char Buffer[ 256 ] ;
int B ;

    B = sprintf( &Buffer, "%-1.250Lf", X ) ; /* Convert */
    Buffer[ B ] = 0 ;
    B = B - 1 ;
    while( Buffer[ B ] == '0' || Buffer[ B ] == ' ' )
    {
	B = B - 1 ;
    } ;
    if( Buffer[ B ] == '.' )
    {
	B = B - 1 ;
    } ;
    Buffer[ B + 1 ] = 0 ;
    return &Buffer ; /* Return result */
} ;


long double XVal( char *S )
{

long double X ;

    if( S == NULL )
    {
	return 0 ;
    } ;
    sscanf( S, "%Lf", &X ) ;
    return X ;
} ;

